# Generated by Django 5.1.1 on 2024-09-25 16:13

import django.db.models.deletion
import django.utils.timezone
import short_stuff.django.models
import short_stuff.lib
from django.db import migrations, models


class Migration(migrations.Migration):

    dependencies = [
        ("contenttypes", "0002_remove_content_type_name"),
        ("lib", "0001_initial"),
    ]

    operations = [
        migrations.CreateModel(
            name="GenericReference",
            fields=[
                (
                    "id",
                    short_stuff.django.models.ShortCodeField(
                        default=short_stuff.lib.gen_shortcode,
                        primary_key=True,
                        serialize=False,
                    ),
                ),
                ("object_id", models.UUIDField(db_index=True)),
                (
                    "content_type",
                    models.ForeignKey(
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        to="contenttypes.contenttype",
                    ),
                ),
            ],
            options={
                "unique_together": {("object_id", "content_type")},
            },
        ),
        migrations.CreateModel(
            name="AuditLog",
            fields=[
                (
                    "id",
                    short_stuff.django.models.ShortCodeField(
                        default=short_stuff.lib.gen_shortcode,
                        primary_key=True,
                        serialize=False,
                    ),
                ),
                ("event_type", models.SlugField()),
                (
                    "level",
                    models.IntegerField(
                        choices=[
                            (0, "Debug"),
                            (1, "Info"),
                            (2, "Warning"),
                            (3, "Error"),
                        ],
                        db_index=True,
                        default=1,
                    ),
                ),
                (
                    "created_on",
                    models.DateTimeField(
                        db_index=True, default=django.utils.timezone.now
                    ),
                ),
                ("data", models.JSONField(default=dict)),
                (
                    "targets",
                    models.ManyToManyField(
                        related_name="audit_logs", to="lib.genericreference"
                    ),
                ),
            ],
        ),
    ]
